=== debian/changelog ===
veyon (4.3.1+repack1-2build2) focal; urgency=medium

  * No-change rebuild against libprocps8

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 27 Feb 2020 07:20:32 +0000

veyon (4.3.1+repack1-2build1) focal; urgency=medium

  * No-change rebuild against libprocps8

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 27 Feb 2020 00:26:26 +0000

veyon (4.3.1+repack1-2) unstable; urgency=medium

  * debian/patches:
    + Add 1003_stop-using-gksudo+kdesudo.patch. Refrain from using old and dead
      kdesudo/gksudo, only use pkexec for launching applications with
      administrative privileges.
  * debian/veyon-service.postinst:
    + Create configuration directories during postinst.
  * debian/veyon-service.postrm:
    + Drop XDG autostart removal code. Left-over from iTALC.
  * debian/control:
    + Add B-D libsystemd-dev.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 17 Feb 2020 10:19:30 +0100

veyon (4.3.1+repack1-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Adapt LONG_DESCRIPTION fields as provided in upstream's README.md file.
    + Add B-D: libfakekey-dev.
  * debian/patches:
    + Update 2002_no-bundled-kitemmodels.patch for Veyon 4.3.1.
    + Trivial rebase of 2001_disable-CPackDefinitions-cmake.patch.
  * debian/copyright:
    + Update copyright attributions.
    + Update auto-generated copyright.in file.
  * debian/rules:
    + White-space fix in get-orig-source tarball.
    + Drop new 3rdparty/libfakekey/ from orig tarball.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 03 Jan 2020 18:00:08 +0100
