=== debian/watch ===
version=3
opts=dversionmangle=s/\+repack1//,downloadurlmangle=s/archive\/v?([\d\.]+).tar.gz/releases\/download\/v$1\/veyon-$1-src.tar.bz2/g \
https://github.com/veyon/veyon/tags .*/archive/v?([\d\.]+).tar.gz
